
package formulario;


/**
 * <p>This is a utility class that is used to parse data obtained from either
 * the quote server or the database and break it into fields for easy use
 * rather than spreading the parsing code around to a thousand different places
 * through out the program.</p>
 */
public final class Data {
	
    /**
     * number of the Item
     */
    private static int num;
    
    /**
     * Name of the Item
     */
    private static String iD;

    /**
     * value of the Item
     */
    private static String value;
    
    public static void parse(String quoteString)
        throws NumberFormatException, StringIndexOutOfBoundsException {
    	
    	int from=0;
        int to = quoteString.indexOf(',');

        // split the string up into it's fields
        if (to == -1) {
        	iD = quoteString;
        	return;
        } else {
        	iD = quoteString.substring(from, to ).trim();
        	from=to+1;
        	to = quoteString.indexOf(',', from);
        }
        if (to == -1) {
        	value = "";
        	return;
        } else {
        	value = quoteString.substring(from, to ).trim();
        	
        }

    }


    /**
     * <p>Return the name of the Item</p>
     *
     * @return name (ticker symbol) of the Item
     * @param  quoteString <code>String</code> to parse for the field data
     */
    public static String getID(String quoteString) {
        parse(quoteString);
        return iD;
    }
    /**
     * <p>Return the value of the Item</p>
     *
     * @return name (ticker symbol) of the Item
     * @param  quoteString <code>String</code> to parse for the field data
     */
    public static String getValue(String quoteString) {
        parse(quoteString);
        return value;
    }

}
