package formulario.save;

import javax.microedition.midlet.*;
import javax.microedition.rms.InvalidRecordIDException;
import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreNotOpenException;
import javax.microedition.lcdui.*;
import javax.microedition.io.file.*;
import javax.microedition.io.*;

import formulario.ItemsDatabase;
import formulario.Setting;
import formulario.SettingsDatabase;

//import formulario.FormularioMIDlet.ItemCommandListener;

import java.io.*;
 
public class SaveToFile extends MIDlet implements CommandListener {
	
	private TextField filenameField;
    private Form saveForm;
    private String memorycard = "fileconn.dir.memorycard";
    
    private Command saveCommand;
    private Command exitCommand;
    private String path;
    

    /**
     * The reference to the <code>ItemDatabase</code> that stores
     * the data
     */
    private ItemsDatabase items = null;

    /**
     * The reference to the <code>SettingsDatabase</code> that stores the settings
     * we need it because we want to add the item name to the first line of the .csv
     */
    private SettingsDatabase settings = null;
 
    public void startApp() {
    	
    	items = new ItemsDatabase();
    	
    	
        try {
            items.open("Items");
        } catch (Exception e) {
        	e.printStackTrace();
        }

        // Open the Settings file
        settings = new SettingsDatabase();

        try {
            settings.open("Settings");
        } catch (Exception e) {
            e.printStackTrace();
        }

        
        
    	saveForm = new Form("Save Items to File");
        filenameField = new TextField("Enter File Name", "data.cvs", 20, TextField.NON_PREDICTIVE);
        
        saveCommand = new Command("Save", Command.SCREEN, 1);
        exitCommand = new Command("Exit", Command.EXIT, 1);
        
        saveForm.append(filenameField);
        
        saveForm.addCommand(saveCommand);
        saveForm.addCommand(exitCommand);
        
        saveForm.setCommandListener(this);
        Display.getDisplay(this).setCurrent(saveForm);
        path = System.getProperty(memorycard);
    }
    
 /**
  * do noting, not used
  */
    public void pauseApp() {
    }
 
    /**
     * do noting, not used
     */
    public void destroyApp(boolean unconditional) {
    }
    
 /**
  * Extracts the name from the displayed form and add an .cvs if it 
  * doesn't have it already 
  * 
  * @return <code>name</code> the name of the file were we are saving the data
  */
    private String getName() {
            
            String name = filenameField.getString();
            if(!name.endsWith(".cvs")){
            	name = name.concat(".cvs");
            }
        return name;
    } 
    
    /**
     * get the field names of the items stored in settings
     * 
     * @return the byte string with the names of the fields 
     */
    private byte[] getFieldsNames() {

    	String it = null;

    	try {
    		RecordEnumeration re = settings.enumerateRecords();
    		String theItem = new String(re.nextRecord());
    		it = Setting.getName(theItem);

    		while (re.hasNextElement() ) {
    			
    			theItem = new String(re.nextRecord());
    			theItem = Setting.getName(theItem);
    			
    			if(! theItem.startsWith("wrong")){
    				it=it.concat(", "+theItem);
    			}
    		}
    	} catch (RecordStoreNotOpenException rsno) {
    		rsno.printStackTrace();
    	} catch (RecordStoreException rs) {
    		rs.printStackTrace();
    	}

    	it=it.concat("\n");

    	return it.getBytes();
    } 
    /**
     * Actually save the file
     * <li> save the items names </li>
     * <li> iterate saving the items names </li>
     * 
     * @param path the address were to save the data
     * @param name the file name
     */
    private void saveFile(String path, String name) {
        try {
            byte [] data;
            String url = path + name;
            String theItem = null;
            FileConnection fconn = (FileConnection)Connector.open(url, Connector.READ_WRITE);
            if (!fconn.exists()) {
                fconn.create();
            }
            data=getFieldsNames();
            OutputStream ops = fconn.openOutputStream();
            ops.write(data);
            

			try {
				RecordEnumeration re = items.enumerateRecords();

				while (re.hasNextElement()) {
					try {
						
						theItem = new String(re.nextRecord());
						theItem=theItem.concat("\n");
			            ops.write(theItem.getBytes());
			            
					} catch (InvalidRecordIDException r){
						r.printStackTrace();
					} catch (RecordStoreNotOpenException r){
						r.printStackTrace();
					} catch (RecordStoreException r) { 
						r.printStackTrace();
					}

				}
			} catch (RecordStoreNotOpenException rsno) {
				rsno.printStackTrace();
			} catch (NullPointerException r) {
				r.printStackTrace();
			}
            
            
            
            ops.close();
            fconn.close();
        }
        catch (IOException ioe) {
            System.out.println("IOException: "+ioe.getMessage());
        }
        catch (SecurityException se) {
            System.out.println("Security exception:" + se.getMessage());
        }
    } 
 
    public void commandAction(Command c, Displayable d) {
        if (c == saveCommand) saveFile(path, getName());
        if (c == exitCommand) this.notifyDestroyed();
    }    
}